;(function($, undefined) {
	'use strict';

	$.fn.priceTable = function(option) {
		var settings = $.extend({
			csvPath: '/assets/include/definition.csv'
		}, option);
		var $obj = $(this);
		var $anchor = $('#priceAnchor');

		$obj.addClass('scrollX');

		$.ajax({
			url: settings.csvPath,
			dataType: 'text'
		}).done(function(data) {
			processData($.csv()(data));
		}).fail(function() {
			console.log('CSV data not found.');
		});

		function processData(data) {
			var dataArray = data;
			var formatArray = [];
			var tableHtml = [];
			var anchorHtml = [];

			var dirName;
			var dirNameOrg;
			var tableName;
			var tableNameOrg;
			var tableCnt;
			var arrayKey1;
			var productName;
			var productNameOrg;
			var rowCnt;
			var arrayKey2;
			var formValue;
			var formRowCnt;
			var arrayKey3;

			var urlOrg = location.href;
			var url = urlOrg.split('/');
			var directory = url[$.inArray('product', url) + 1];

			//CSV data formatting
			for (var i=0; i<dataArray.length; i++) {
				dirNameOrg = dirName;
				tableNameOrg = tableName;
				productNameOrg = productName;

				dataArray[i] = formatElement(dataArray[i]);

				if(i==0) {
					formatArray['header'] = dataArray[i];
				} else {
					if(dirName !== dataArray[i][6]) {
						dirName = dataArray[i][6];
						formatArray[dirName] = [];
						tableCnt = 0;
					};
					if(tableName !== dataArray[i][7] || dirNameOrg !== dirName) {
						tableName = dataArray[i][7];
						arrayKey1 = tableCnt;
						formatArray[dirName][arrayKey1] = [];
						tableCnt++;
						rowCnt = 0;
					};
					if(productName !== dataArray[i][0] || tableNameOrg !== tableName || dirNameOrg !== dirName) {
						productName = dataArray[i][0];
						arrayKey2 = rowCnt;
						formatArray[dirName][arrayKey1][arrayKey2] = [];
						rowCnt++;
						formRowCnt = 0;
					};
					if(formValue !== dataArray[i][1] || productNameOrg !== productName || tableNameOrg !== tableName || dirNameOrg !== dirName) {
						formValue = dataArray[i][1];
						arrayKey3 = formRowCnt;
						formatArray[dirName][arrayKey1][arrayKey2][arrayKey3] = [];
						formRowCnt++;
					};

					formatArray[dirName][arrayKey1][arrayKey2][arrayKey3].push(dataArray[i]);
				};
			};

//console.log(formatArray)

			//Create table HTML
			for(var i=0; i<formatArray[directory].length; i++) {
				var titleVal = '';
				var anchorID = '';

				//Cell deletion
				var deleteCellArray = [];
				var trCnt = 0;
				for(var j=0; j<formatArray[directory][i].length; j++) {
					for(var k=0; k<formatArray[directory][i][j].length; k++) {
						deleteCellArray[trCnt] = [];
						for(var l=0; l<formatArray[directory][i][j][k].length; l++) {
							for(var m=0; m<formatArray[directory][i][j][k][l].length; m++) {
								if(j==0) {
									titleVal = formatArray[directory][i][j][k][l][8];
									if(k==0 && l==0 && m==0) {
										anchorID = ' id="' + formatArray[directory][i][j][k][l][7] + '"';
										anchorHtml.push('<li><a href="#' + formatArray[directory][i][j][k][l][7] + '">' + formatArray[directory][i][j][k][l][8] + '</a></li>');
									};
								};
								if(formatArray[directory][i][j][k][l][m] == '@@@') {
									deleteCellArray[trCnt].push(m);
								};
							};
						};
						trCnt++;
					};
				};

				var deleteCell = array_intersect(deleteCellArray[0], deleteCellArray);

				tableHtml.push('<div class="section">\n<div' + anchorID + ' class="hdg03 mb15"><h2>' + titleVal + '</h2></div>');
				tableHtml.push('<div class="scrollX">\n<div class="tableType3">\n<table>\n');

				//Table
				for(var j=0; j<formatArray[directory][i].length; j++) {
					//Thead
					if(j==0) {
						tableHtml.push('<thead>\n<tr>\n');
						for(var k=0; k<formatArray['header'].length; k++) {
							var returnFlag = false;

							if(k<6) {
								//Cell deletion
								for(var l=0; l<deleteCell.length; l++){
									if(deleteCell[l] == k) {
										returnFlag = true;
									};
								};
								if(returnFlag) {
									returnFlag = false;
									continue;
								};

								tableHtml.push('<th>', formatArray['header'][k], '</th>\n');
							};
						};
						tableHtml.push('</tr>\n</thead>\n<tbody>\n');
					};

					//Tbody
					//Tr
					var trSum = 0;
					for(var k=0; k<formatArray[directory][i][j].length; k++) {
						trSum += formatArray[directory][i][j][k].length;
					};

					var rowFlag;
					for(var k=0; k<formatArray[directory][i][j].length; k++) {
						if(formatArray[directory][i][j].length>1 || formatArray[directory][i][j][k].length>1) {
							rowFlag = true;
						} else {
							rowFlag = false;
						};

						//Td
						for(var l=0; l<formatArray[directory][i][j][k].length; l++) {
							tableHtml.push('<tr>\n');
							for(var m=0; m<formatArray[directory][i][j][k][l].length; m++) {
								var rowspan = '';
								var className = '';
								var returnFlag = false;

								if(rowFlag) {
									if(m==0) {
										if(k==0) {
											if(l>0) {
												continue;
											};
											if(l==0) {
												rowFlag = true;
												rowspan = ' rowspan="' + trSum + '"';
											};
										} else {
											continue;
										};
									};
								};

								if(rowFlag && l==0 && m==1) {
									rowFlag = true;
									rowspan = ' rowspan="' + formatArray[directory][i][j][k].length + '"';
								};
								if(rowFlag && l>0 && m==1) {
									continue;
								};

								if(m<6) {
									var tag = 'td';

									if(j==0) {
										titleVal = formatArray[directory][i][j][k][8];
									};

									//Cell deletion
									for(var n=0; n<deleteCell.length; n++){
										if(deleteCell[n] == m) {
											returnFlag = true;
										};
									};
									if(returnFlag) {
										returnFlag = false;
										continue;
									};

									if(m==0) {
										tag = 'th';
									};

									if(m==5) {
										className = ' class="nowrap"';
									};

									tableHtml.push('<' + tag + rowspan + className + '>\n');
									var value;
									if(formatArray[directory][i][j][k][l][m] == '@@@') {
										value = '&nbsp;';
									} else {
										value = formatArray[directory][i][j][k][l][m];
									};
									tableHtml.push(value);
									tableHtml.push('</' + tag + '>\n');
								};
							};
							tableHtml.push('</tr>\n');
						};
					};
				};

				tableHtml.push('</tbody>\n</table>\n</div>\n</div>\n');
				tableHtml.push('<div class="guideArrow"><img src="/content/000000008.png" alt="" /></div>\n</div>\n');
			};

			$anchor.append('<ul>' + anchorHtml.join('') + '</ul>');
			$obj.append(tableHtml.join(''));
			$anchor.find('a').on('click', pageAnchorScrollFunc);
		};

		function array_intersect(array1, array2) {
			if (!Array.prototype.filter) {
				Array.prototype.filter = function(fun /*, thisp */) {
					"use strict";

					if (this === void 0 || this === null)
					throw new TypeError();

					var t = Object(this);
					var len = t.length >>> 0;
					if (typeof fun !== "function")
					throw new TypeError();

					var res = [];
					var thisp = arguments[1];
					for (var i = 0; i < len; i++) {
						if (i in t) {
							var val = t[i]; // in case fun mutates this
							if (fun.call(thisp, val, i, t))
								res.push(val);
						};
					};

					return res;
				};
			};

			var result = array1.filter(function(n) {
				var existCnt = 0;
				for(var i=0; i<array2.length; i++) {
					if($.inArray(n, array2[i]) !== -1) {
						existCnt++;
					};
				};
				if(existCnt == array2.length) {
					return n;
				};
			});

			return result;
		};

		function formatElement(array) {
			//Delete element
			array.splice(0, 1);
			array.splice(1, 1);
			array.splice(9, 1);

			//Format element
			var formatData = [
				array[3],
				array[4],
				array[5],
				array[8],
				array[6],
				array[7],
				array[0],
				array[2],
				array[1]
			];

			return formatData;
		};

		// Smooth scroll
		function pageAnchorScrollFunc(e){
			var hrefName = $(e.currentTarget).attr('href');

			if( hrefName.indexOf('#') === -1){
				return;
			};

			// Check current page or not
			var clickedUrl = hrefName.split(/#.*/)[0];

			if( clickedUrl !== "" && typeof clickedUrl !== "undefined" ){
				var thisUrl = oimc.generalSettings.config.THIS_HREF;
				thisUrl = thisUrl.replace(/https?:\/\/[^\/]+/, '');	// remove domain
				thisUrl = thisUrl.replace(/#.*/, ''); // remove hash
				thisUrl = thisUrl.replace(/index[0-9]?\.(html|htm)$/, '');	// remove index.html, index2.html

				clickedUrl = clickedUrl.replace(/https?:\/\/[^\/]+/, '');	// remove domain
				clickedUrl = clickedUrl.replace(/index[0-9]?\.(html|htm)$/, '');	// remove index.html, index2.html

				if( thisUrl !== clickedUrl ){
					return;
				};
			};

			e.preventDefault();

			// Only hash
			hrefName = hrefName.match(/#.*/)[0]

			var $obj = $( hrefName );

			if( $obj.length === 0 ){
				return;
			};

			var ptY = $obj.offset().top - ($('.productHeader').get(0).offsetHeight + 10);

			$('html, body').stop()
				.animate({
					scrollTop: ptY
				}, {
					duration: 800,
					easing: 'easeOutCubic',
					complete: function(){
						// rewrite hash
						// window.location.hash = '';
					}
				});
		};

		return this;
	};

	$(window).on('load', function() {
		$('#priceTable').priceTable();
	});
})(jQuery);